#!/bin/bash
# Copyright (c) 2000-2020 Synology Inc. All rights reserved.

CONTACTS_SCRIPT_DIR="/var/packages/Contacts/target/scripts/mailplus_server_hook"
USER_SMTP_CHANGE_HOOK_SCRIPT="contacts_user_smtp_change_hook.py"
VALID_USER_LIST_HOOK_SCRIPT="contacts_valid_user_list_hook.py"

MAILPLUS_SERVER="/var/packages/MailPlus-Server/target"
MAILPLUS_SERVER_USER_SMTP_CHANGE_HOOK_DIR="${MAILPLUS_SERVER}/hook/mailclient_user_smtp_change_hook"
MAILPLUS_SERVER_VALID_USER_LIST_HOOK_DIR="${MAILPLUS_SERVER}/hook/mailclient_valid_user_list_hook"

InstallServerHooks()
{
    cp ${CONTACTS_SCRIPT_DIR}/${USER_SMTP_CHANGE_HOOK_SCRIPT} $MAILPLUS_SERVER_USER_SMTP_CHANGE_HOOK_DIR
    cp ${CONTACTS_SCRIPT_DIR}/${VALID_USER_LIST_HOOK_SCRIPT} $MAILPLUS_SERVER_VALID_USER_LIST_HOOK_DIR
}

UninstallServerHooks()
{
    rm -f ${MAILPLUS_SERVER_USER_SMTP_CHANGE_HOOK_DIR}/${USER_SMTP_CHANGE_HOOK_SCRIPT}
    rm -f ${MAILPLUS_SERVER_VALID_USER_LIST_HOOK_DIR}/${VALID_USER_LIST_HOOK_SCRIPT}
}

case $1 in
    --install)
        InstallServerHooks
        exit 0
    ;;
    --uninstall)
        UninstallServerHooks
        exit 0
    ;;
esac
